-- object rotation about Y axis
second =  0.11574074051168E-04

minute = 60 * second
  hour = 60 * minute
   day = 24 * hour -- dam well better be 1.0000 (tested: it is)

-- arbitrary duration for all movements. For some it's too slow, for others it's too fast.
dT = 10*second

xAxis = celestia:newvector( 1, 0, 0)
yAxis = celestia:newvector( 0, 1, 0)
zAxis = celestia:newvector( 0, 0, 1)
  xPi = celestia:newrotation( xAxis, math.pi)
  yPi = celestia:newrotation( yAxis, math.pi)
  yPi2 = celestia:newrotation( yAxis, -math.pi/2)
  yR0 = celestia:newrotation( yAxis, 0)
  zPi = celestia:newrotation( zAxis, math.pi)

-- --------------------------------------------------
-- door in front of Servalan's cruiser 
-- --------------------------------------------------
HQDoor0_ = {}
-- time to have opened door
--	HQDoor0_.T1 = 2747128.3999
	HQDoor0_.T1 = 2747128.40667499987
	HQDoor0_.T0 = HQDoor0_.T1 - 10.0*second
-- time to have closed door
--	HQDoor0_.T3 = 2747128.4001
	HQDoor0_.T3 = 2747128.40687499987
--	HQDoor0_.T3 = 2747128.5
	HQDoor0_.T2 = HQDoor0_.T3 - 10.0*second

-- door opens to an angle of 120 degrees
-- velocity to rotate door: 120 degrees in 10 seconds
	HQDoor0_.V = math.rad(120.0)/(10.0*second)




HQRotDoor0 = function ( date )
	local Angle = 0.0

     	if (date <= HQDoor0_.T0)
	then
	  Angle = math.rad(0.0)
     	elseif ((date > HQDoor0_.T0) and (date <= HQDoor0_.T1))
      	then
	  Angle = 0.0 - HQDoor0_.V*(date-HQDoor0_.T0)
	elseif ((date > HQDoor0_.T1) and (date <= HQDoor0_.T2))
	then
	   Angle = - math.rad(120.0)
     	elseif ((date > HQDoor0_.T2) and (date <= HQDoor0_.T3))
      	then
	  Angle = - math.rad(120.0) + HQDoor0_.V*(date-HQDoor0_.T2)
     	elseif (date > HQDoor0_.T3)
	then
	  Angle = math.rad(0.0)
      	end

--	   Angle = - math.rad(120.0)
	return celestia:newrotation( xAxis, Angle)*yPi
end

HQDoor0proto =
{
   Amplitude = 0,
   Period    = 1,
}

-- constructor method
function HQDoor0proto:new(o)
   o = o or {}  -- create table if one not provided
   setmetatable(o, self)
   self.__index = self

   -- set the period to whatever value was specified in the ssc file;
   -- slightly confusing because Celestia is case sensitive--period must
   -- be lowercase, but the field from the ssc file is capitalized.
   o.period = o.Period

   return o
end

-- The orientation function. This implementation produces a back and forth
-- wobble of Amplitude degrees about the z axis.
function HQDoor0proto:orientation(tjd)

   -- compute a quaternion representing the orientation
	local qNow = HQRotDoor0( tjd )
	return qNow.w, qNow.x, qNow.y, qNow.z
end

function HQDoor0(sscvals)
   -- create a new HQDoor0 rotation object
   return HQDoor0proto:new(sscvals)
end
-- --------------------------------------------------
-- door in front of Travis' pursuit ship
-- --------------------------------------------------
HQDoor1_ = {}
-- time to have opened door
	HQDoor1_.T1 = 2747128.3999
	HQDoor1_.T0 = HQDoor1_.T1 - 10.0*second
-- time to have closed door
	HQDoor1_.T3 = 2747128.4001
	HQDoor1_.T2 = HQDoor1_.T3 - 10.0*second

-- door opens to an angle of 120 degrees
-- velocity to rotate door: 120 degrees in 10 seconds
	HQDoor1_.V = math.rad(120.0)/(10.0*second)


HQRotDoor = function ( date )
	local Angle = 0.0

     	if (date <= HQDoor1_.T0)
	then
	  Angle = math.rad(0.0)
     	elseif ((date > HQDoor1_.T0) and (date <= HQDoor1_.T1))
      	then
	  Angle = 0.0 - HQDoor1_.V*(date-HQDoor1_.T0)
	elseif ((date > HQDoor1_.T1) and (date <= HQDoor1_.T2))
	then
	   Angle = - math.rad(120.0)
     	elseif ((date > HQDoor1_.T2) and (date <= HQDoor1_.T3))
      	then
	  Angle = - math.rad(120.0) + HQDoor1_.V*(date-HQDoor1_.T2)
     	elseif (date > HQDoor0_.T3)
	then
	  Angle = math.rad(0.0)
      	end

	return celestia:newrotation( xAxis, Angle)
end

HQDoor1proto =
{
   Amplitude = 0,
   Period    = 1,
}

-- constructor method
function HQDoor1proto:new(o)
   o = o or {}  -- create table if one not provided
   setmetatable(o, self)
   self.__index = self

   -- set the period to whatever value was specified in the ssc file;
   -- slightly confusing because Celestia is case sensitive--period must
   -- be lowercase, but the field from the ssc file is capitalized.
   o.period = o.Period

   return o
end

-- The orientation function. This implementation produces a back and forth
-- wobble of Amplitude degrees about the z axis.
function HQDoor1proto:orientation(tjd)

   -- compute a quaternion representing the orientation
	local qNow = HQRotDoor( tjd )
	return qNow.w, qNow.x, qNow.y, qNow.z
end

function HQDoor1(sscvals)
   -- create a new HQDoor1 rotation object
   return HQDoor1proto:new(sscvals)
end

-- =====================================================
--  blink docking lights for both docking bays
-- =====================================================
hq_blink = function (date,num)

	local lamp_pos = 1e16

-- blink lights if either of the launch-bay doors is down fully

	if (((date > HQDoor1_.T1) and (date <= HQDoor1_.T2))
 	  or ((date > HQDoor0_.T1) and (date <= HQDoor0_.T2)))
	then
		local day = date - 2747128
		local sec = day/second
		local int,frac = math.modf(sec)
		local qsec,fracq = math.modf(frac*4)
		local qfrac = math.fmod(qsec+num,4)
--		s = "qfrac = "..qfrac
	 lamp_pos = 1e16*qfrac
	end
	
--s = " lamp_pos = "..lamp_pos
--celestia:flash(s)

	return lamp_pos
end

HQ_blink = function ( customParams )
	local orbit = { params= customParams }
	orbit.boundingRadius = 1e-4

	function orbit:position (tjd)
		local nbr = self.params.Phase
		local blink = hq_blink(tjd,nbr)
		return blink,0,0
	end

return orbit
end

-- =====================================================
--  blink warning lights when doors are open
-- =====================================================
hq_warn = function (date,num)


	local lamp_pos = 1e16

-- blink lights if specified launch-bay door is open

	if ( num==1 and((date > HQDoor1_.T0) and (date <= HQDoor1_.T3))
 	  or (num==0 and (date > HQDoor0_.T0) and (date <= HQDoor0_.T3)))
	then
		local day = date - 2747128
		local sec = day/second
		local int,frac = math.modf(sec)
		local qsec,fracq = math.modf(frac*4)
		local qfrac = math.fmod(qsec+num,4)
--		s = "qfrac = "..qfrac
	 lamp_pos = 1e16*qfrac
	end
	
--s = " lamp_pos = "..lamp_pos
--celestia:flash(s)

	return lamp_pos
end

HQ_warn = function ( customParams )
	local orbit = { params= customParams }
	orbit.boundingRadius = 1e-4

	function orbit:position (tjd)
		local nbr = self.params.Phase
		local warn = hq_warn(tjd,nbr)
		return warn,0,0
	end

return orbit
end

-- --------------------------------------
--  expand image of explosion
-- --------------------------------------

hq_explode = function ( date )

	   -- get explosion
	   local obj = celestia:find ("HQ_star/HQ_planet/Explosion" )
	   local t1 = 2747128.349980
	   local t2 = t1 + 10*second

	   if (date < t1 )
	    then
	      obj:setvisible(false)
	   elseif ((date >= t1) and (date < t2)) 
	    then 
	       obj:setvisible(true)
	    -- increase radius
	       local r0 = 10
	       local k = 4e5
	       obj:setradius( r0 * k * (date - t1) )
	   else 
     	    obj:setvisible(false)
	   end

	   return 1
end


HQ_explode = function ( customParams )
	local orbit = { params= customParams }
	orbit.boundingRadius = 1e-4

	function orbit:position (tjd)
		local warn = hq_explode(tjd)
		return 0,0,0
	end

return orbit
end
